#include <sys/types.h> 
#include <unistd.h>
#include <stdio.h>
#define MAXIMO  512       //Tamao de string de comando a ser ejecutado
#define PING    "ping "   //Definicion comando ping 
#define FICHERO "datos.txt"
FILE * datos;             //descriptor a fichero de datos

//Funcion main recibe como argumentos los parametros ingresados por usuario

int main(int argc, char **argv)
{
   FILE * pipa=NULL;
  
   char aux[500];   //Borrar
   char comando[MAXIMO];   //variable que contendra comando a ser ejecutado
   char s1[]="=";         //Simbolo utilizado para particionar salida del ping
   pid_t pid;
   int temp,temp2;        //variables que contendran datos de tiempo y secuencia de paquetes recibidos
   int secuencia[10]={0},count=0,j=0,k=0,l=0;   //Variables usadas en ventana para calculo perdida de paquetes
   int porcentaje=0;
   int umbral=0,sem=0;

   datos = fopen(FICHERO,"w");  //Crea fichero para almacenar los datos obtenidos
   fprintf(datos," Monitoreo destino: %s\n\n",argv[1]);
   fprintf(datos,"tiempo\t Perdida    secuencia tiempo_ida_vuelta\n\t  [\%]\t\tack\n");
   fclose(datos);                  //cerramos fichero que contiene encabezado
   
   strcpy(comando, PING);           //comando ping
   
// Verificacin de cantidad de parmetros ingresados
   switch(argc) {
    case 1:
      strcat(comando, "localhost");    //Condicion ping local
      break;
     
    case 2:
      strcat(comando, *(++argv));
      break;
      
    case 4:
      strcat(comando, *(++argv));
      break;
      
    default:
      printf("Nmero incorrecto de parmetros\n");
      exit(1);
   }
//Fin verificacin cantidad parmetros ingresados

   umbral=atoi(argv[2]);
   
   pipa= popen (comando,"r");
   if (pipa == NULL)   //verificamos si se puede ejecutar comando
     {	printf("No se puede abrir %s",comando); //envio mensaje de error
	exit (-1);
     }
   
   if ((pid = fork()) < 0)  //Creacion proceso hijo
     {   
	printf("fork error\n");
	exit(-1);
     }
   
   if(pid==0)   //Hijo encargado de graficar
     { if(argc<3)
       {
	  
	sleep(2);
	crear_gnu(300);
       	system("gnuplot grafico.gnu");
       }	
     }
   else{                             //Proceso padre   
   fgets (aux,500,pipa);             //Se adquiere salida del comando ping
   fgets (aux,500,pipa);
   
   while(1){
      datos = fopen(FICHERO,"a");
      fprintf(datos,"%d\t",count);
//Calculo de porcentaje para una ventana movil de 10 segundos...
      if(count>9)
	{
	   porcentaje=((secuencia[l]-secuencia[j])-9)*10;
	 if(porcentaje>100) porcentaje=100;     //Ajuste del valor de porcentaje
	   fprintf(datos,"   %d\t\t",porcentaje);
	   j++;
	 if(j==10) j=0;
//Obtencin de condicionantes para el envio de mail
         if (porcentaje>umbral && sem==0 &&argc==4)
	     {
		fclose(datos);
		printf("se envi reporte a %s\n",argv[1]);
		mail(argv[1],FICHERO);
		datos=fopen(FICHERO,"a");
		sem=1;
	     }
	   
         else 
	     {
	     if(porcentaje<=umbral)
		sem=0;
	     }
	}
      else
	  fprintf(datos,"   0\t\t");
      
   if(!feof (pipa))
   {
     strtok(aux,s1);
     temp = strtok(NULL,s1);         //Almacena secuencia de ping
     strtok(NULL,s1);
     temp2 = strtok(NULL,s1);        //Almacena tiempo de ida y regreso
     temp = strtok(temp," ");
     fprintf(datos,"%s\t",temp);       //Almacena secuencia en archivo
     fprintf(datos,"%s",temp2);   //Almacena tiempo en archivo
    
     secuencia[k]=atoi(temp);   //se convierte secuencia en entero
     l=k;
     k++;
     if(k==10) k=0;  //Reinicio del contador de datos almacenados en arreglo    
   }
   else
	fprintf(datos,"%d  %s  %s\n",count,temp,temp2);   //En caso de pasar el tiemo repite lo acumulado 
   
     fclose(datos);
     fgets (aux, 500, pipa);   //nuevamente se lee desde la pipa salida del comando ping
     count++;
     sleep(1);
   
   }
   }   //Fin proceso padre
   
   /* Se cierra el fichero */
   pclose (pipa);
    exit(0);
}
